<template>
  <form class="block" @submit.prevent="submit(model)">
    <input class="block border mb-1" v-model="model.title" placeholder="Title" type="text">
    <textarea class="block border mb-1" v-model="model.description" placeholder="Description" cols="30" rows="10"/>
    <input class="block border mb-1" v-model="model.due" type="date">

    <objective-form
      class="ml-4"
      v-for="objective in model.objectives"
      :key="Math.random()"
      :objective="objective"
      :parent="model"
      :helper="recursiveComponentHelper"
    />

    <button class="block border mb-1" @click.prevent="addFirstLevelObjective">Add Task</button>
    <button class="block border mb-1 bg-green-600">Submit</button>
  </form>
</template>

<script lang="ts">
  import Vue from 'vue'
  import { Goal, Objective } from '~/utils/models'
  import ObjectiveForm from '~/components/ObjectiveForm.vue'

  export default Vue.extend({
    components: {
      ObjectiveForm
    },

    props: {
      goal: {
        type: Object as () => Goal,
        default () {
          return new Goal()
        }
      },
      submit: {
        type: Function,
        default: () => {}
      }
    },

    data () {
      const model: Goal = Object.assign({}, this.goal)
      return {
        model
      }
    },

    methods: {
      /**
       * Used by sub-forms in order to update
       * data model of parent form
       * @param callback
       */
      recursiveComponentHelper (callback: Function) {
        callback()
      },

      addFirstLevelObjective () {
        this.goal.objectives.push(new Objective())
      },
    },
  })
</script>
